/*
 * $Id$
*/

/*
 * HMG 4 demo
 * (c) 2010 Roberto Lopez <mail.box.hmg@gmail.com>
*/

#include "hmg.ch"

MEMVAR oWindow

FUNCTION main()

   PRIVATE oWindow

   HbQt_ErrorSys()

   WITH OBJECT oWindow := WINDOW():New( "MainForm" )
      :Row     := 0
      :Col     := 0
      :Width   := 600
      :Height  := 600
      :Title   := "TREE demo (oop style)"
      :Type    := WND_MAIN
      :OnInit  := { || MainFrmOnInit() }

      WITH OBJECT BUTTON():New( "BtnExit" )
         :Row           := 10
         :Col           := 10
         :Width         := 90
         :Height        := 20
         :Caption       := "Exit"
         :OnClick       = { || MainFrmExit() }
      END WITH

      WITH OBJECT BUTTON():New( "BtnDel" )
         :Width         := 90
         :Height        := 20
         :Row           := 10
         :Col           := 110
         :Caption       := "Del Item"
         :OnClick       = { || TreeDelItem() }
      END WITH

      WITH OBJECT BUTTON():New( "BtnDelAll" )
         :Width         := 90
         :Height        := 20
         :Row           := 10
         :Col           := 210
         :Caption       := "Del All"
         :OnClick       = { || TreeDelAll() }
      END WITH

      WITH OBJECT BUTTON():New( "BtnNoRoot" )
         :Width         := 90
         :Height        := 20
         :Row           := 10
         :Col           := 310
         :Caption       := "No RootButt"
         :OnClick       = { || TreeNoRoot() }
      END WITH

      WITH OBJECT BUTTON():New( "BtnCaption" )
         :Width         := 90
         :Height        := 20
         :Row           := 50
         :Col           := 10
         :Caption       := "Tree caption"
         :OnClick       = { || TreeCaption() }
      END WITH

      WITH OBJECT BUTTON():New( "BtnNoImage" )
         :Width         := 90
         :Height        := 20
         :Row           := 50
         :Col           := 110
         :Caption       := "No images"
         :OnClick       = { || TreeNoImages() }
      END WITH

      WITH OBJECT TREE():New( "Tree1" )
         :Row           := 80
         :Col           := 10
         :Width         := 400
         :Height        := 300
         :ItemImages    := { "folder_close.png", "folder_open.png" }
         :NodeImages    := { "world.png", "world_red.png" }
         :OnChange      := { || TreeOnChange() }
         :OnDblClick    := { || TreeOnDblClick() }

         :AddNode( "Item1" )
            :AddTreeItem( "Item1.1" )
            :AddTreeItem( "Item1.2" )
         :EndNode()

         :AddNode( "Item2" )
            :AddTreeItem( "Item2.1" )

            :AddNode( "Item2.2" )
               :AddTreeItem( "Item2.2.1" )
            :EndNode()

            :AddTreeItem( "Item2.3" )
         :EndNode()

      END WITH

   END WITH

   oWindow:Activate()

RETURN NIL

STATIC FUNCTION MainFrmExit()

   HMGAPP():MainForm:Release()
   
RETURN NIL

STATIC FUNCTION MainFrmOnInit()

   HMGAPP():MainForm:Center()
   
RETURN NIL

STATIC FUNCTION TreeOnChange()

   MsgStop( "I'm ON item " + hb_ValToExp( HMGAPP():MainForm:Tree1:Value ) )

RETURN NIL

STATIC FUNCTION TreeOnDblClick()

   MsgStop( "Caption " + hb_ValToExp( HMGAPP():MainForm:Tree1:Item( HMGAPP():MainForm:Tree1:Value ) ) )

RETURN NIL

STATIC FUNCTION TreeDelItem()

   LOCAL nValue := HMGAPP():MainForm:Tree1:Value

   IF nValue > 0
      MsgStop( "I will delete item " + hb_ValToExp( nValue ) )
      HMGAPP():MainForm:Tree1:DeleteItem( nValue )
      MsgStop( "I'm ON item " + hb_ValToExp( HMGAPP():MainForm:Tree1:Value ) )
   ELSE
      MsgStop( "You must select an Item" )
   ENDIF

RETURN NIL

STATIC FUNCTION TreeDelAll()

   HMGAPP():MainForm:Tree1:DeleteAllItems()
   MsgStop( "There are " + hb_ValToExp( HMGAPP():MainForm:Tree1:Value ) )
   
   MsgStop( "Now I will create with different images and add some items" )

   HMGAPP():MainForm:Tree1:AddNode( "Item1", { "laptop1.png", "laptop2.png" } )
      HMGAPP():MainForm:Tree1:AddTreeItem( "Item1.1", { "card_mast.png", "card_visa.png" } )
      HMGAPP():MainForm:Tree1:AddTreeItem( "Item1.2", NIL )
   HMGAPP():MainForm:Tree1:EndNode()

   HMGAPP():MainForm:Tree1:AddNode( "Item2", { "laptop1.png", "laptop2.png" } )
      HMGAPP():MainForm:Tree1:AddTreeItem( "Item2.1", { "card_mast.png", "card_visa.png" } )

      HMGAPP():MainForm:Tree1:AddNode( "Item2.2", { "laptop1.png", "laptop2.png" } )
         HMGAPP():MainForm:Tree1:AddTreeItem( "Item2.2.1", { "card_mast.png", "card_visa.png" } )
      HMGAPP():MainForm:Tree1:EndNode()

      HMGAPP():MainForm:Tree1:AddTreeItem( "Item2.3", { "card_mast.png", "card_visa.png" } )
   HMGAPP():MainForm:Tree1:EndNode()

   HMGAPP():MainForm:Tree1:AddItem( "New Item1", 4, { "white_paper.png" } )
   HMGAPP():MainForm:Tree1:AddItem( "New Item2", 1, { "white_paper.png" } )

RETURN NIL

STATIC FUNCTION TreeNoRoot()

   IF HMGAPP():MainForm:Tree1:RootButton == .T.
      HMGAPP():MainForm:Tree1:RootButton := .F.
   ELSE
      HMGAPP():MainForm:Tree1:RootButton := .T.
   ENDIF

RETURN NIL

STATIC FUNCTION TreeCaption()

   IF HMGAPP():MainForm:Tree1:Caption == ""
      HMGAPP():MainForm:Tree1:Caption := "This is a caption"
   ELSE
      HMGAPP():MainForm:Tree1:Caption := NIL
   ENDIF

RETURN NIL

STATIC FUNCTION TreeNoImages()

   IF LEN( HMGAPP():MainForm:Tree1:ItemImages ) == 0
      HMGAPP():MainForm:Tree1:ItemImages := { "folder_close.png", "folder_open.png" }
      HMGAPP():MainForm:Tree1:NodeImages := { "world.png", "world_red.png" }
   ELSE
      HMGAPP():MainForm:Tree1:ItemImages := {}
      HMGAPP():MainForm:Tree1:NodeImages := {}
   ENDIF

   HMGAPP():MainForm:Tree1:DeleteAllItems()

   HMGAPP():MainForm:Tree1:AddNode( "Item1" )
      HMGAPP():MainForm:Tree1:AddTreeItem( "Item1.1" )
      HMGAPP():MainForm:Tree1:AddTreeItem( "Item1.2" )
   HMGAPP():MainForm:Tree1:EndNode()

   HMGAPP():MainForm:Tree1:AddNode( "Item2" )
      HMGAPP():MainForm:Tree1:AddTreeItem( "Item2.1" )

      HMGAPP():MainForm:Tree1:AddNode( "Item2.2" )
         HMGAPP():MainForm:Tree1:AddTreeItem( "Item2.2.1" )
      HMGAPP():MainForm:Tree1:EndNode()

      HMGAPP():MainForm:Tree1:AddTreeItem( "Item2.3" )
   HMGAPP():MainForm:Tree1:EndNode()

RETURN NIL
