/*
 * $Id$
*/

/*
 * HMG 4 demo
 * (c) 2010 Roberto Lopez <mail.box.hmg@gmail.com>
*/

#include "hmg.ch"

# xcommand DEFINE XTREE <tagreference> ;
      [ <dummy1: OF, PARENT> <oParent> ] ;
      [ TOVAR <varname> ] ;
   => ;
   With Object [<varname> :=] TREE():New( <"tagreference">[ , <oParent> ] ) ;

#xcommand XNODE <cItemCaption> [ IMAGES <aImages> ][ ID <nItemId> ] ;
   => :AddNode( <cItemCaption>, <aImages>, <nItemId> )

#xcommand END XNODE => :EndNode()

#xcommand XTREEITEM <cItemCaption> [ IMAGES <aImages> ][ ID <nItemId> ] ;
   => :AddTreeItem( <cItemCaption>, <aImages>, <nItemId> )

#xcommand ITEMIMAGES       <value>   =>   :ItemImages       := <value>
#xcommand NODEIMAGES       <value>   =>   :NodeImages       := <value>

MEMVAR MainForm

FUNCTION main()

   PUBLIC MainForm

   HbQt_ErrorSys()

   DEFINE WINDOW MainForm
      ROW     0
      COL     0
      WIDTH   600
      HEIGHT  600
      TITLE   "TREE demo (xbase+oop style)"
      TYPE    WND_MAIN
      ONINIT  MainFrmOnInit()

      DEFINE BUTTON BtnExit
         ROW            10
         COL            10
         WIDTH          90
         HEIGHT         20
         CAPTION        "Exit"
         ONCLICK        MainFrmExit()
      END BUTTON

      DEFINE BUTTON BtnDel
         WIDTH          90
         HEIGHT         20
         ROW            10
         COL            110
         CAPTION        "Del Item"
         ONCLICK        TreeDelItem()
      END BUTTON

      DEFINE BUTTON BtnDelAll
         WIDTH          90
         HEIGHT         20
         ROW            10
         COL            210
         CAPTION        "Del All"
         ONCLICK       TreeDelAll()
      END BUTTON

      DEFINE BUTTON BtnNoRoot
         WIDTH          90
         HEIGHT         20
         ROW            10
         COL            310
         CAPTION        "No RootButt"
         ONCLICK        TreeNoRoot()
      END BUTTON

      DEFINE BUTTON BtnCaption
         WIDTH          90
         HEIGHT         20
         ROW            50
         COL            10
         CAPTION        "Tree caption"
         ONCLICK        TreeCaption()
      END BUTTON

      DEFINE BUTTON BtnNoImage
         WIDTH          90
         HEIGHT         20
         ROW            50
         COL            110
         CAPTION        "No images"
         ONCLICK        TreeNoImages()
      END BUTTON

      DEFINE XTREE Tree1
         ROW            80
         COL            10
         WIDTH          400
         HEIGHT         300
         ONCHANGE       TreeOnChange()
         ONDBLCLICK     TreeOnDblClick()
         ITEMIMAGES     { "folder_close.png", "folder_open.png" }
         NODEIMAGES     { "world.png", "world_red.png" }

         XNODE "Item1"
            XTREEITEM "Item1.1"
            XTREEITEM "Item1.2"
         END XNODE

         XNODE "Item2"
            XTREEITEM "Item2.1"

            XNODE "Item2.2"
               XTREEITEM "Item2.2.1"
            END XNODE

            XTREEITEM "Item2.3"
         END XNODE

      END TREE

   END WINDOW

   ACTIVATE WINDOW MainForm

RETURN NIL

STATIC FUNCTION MainFrmExit()

   MainForm:Release()

RETURN NIL

STATIC FUNCTION MainFrmOnInit()

   MainForm:Center()

RETURN NIL

STATIC FUNCTION TreeOnChange()

   MsgStop( "I'm ON item " + hb_ValToExp( MainForm:Tree1:Value ) )

RETURN NIL

STATIC FUNCTION TreeOnDblClick()

   MsgStop( "Caption " + hb_ValToExp( MainForm:Tree1:Item( MainForm:Tree1:Value ) ) )

RETURN NIL

STATIC FUNCTION TreeDelItem()

   LOCAL nValue := MainForm.Tree1.Value

   IF nValue > 0
      MsgStop( "I will delete item " + hb_ValToExp( nValue ) )
      MainForm:Tree1:DeleteItem( nValue )
      MsgStop( "I'm ON item " + hb_ValToExp( MainForm:Tree1:Value ) )
   ELSE
      MsgStop( "You must select an Item" )
   ENDIF

RETURN NIL

STATIC FUNCTION TreeDelAll()

   MainForm:Tree1:DeleteAllItems()
   MsgStop( "There are " + hb_ValToExp( MainForm:Tree1:Value ) )
   
   MsgStop( "Now I will create with different images and add some items" )

   MainForm:Tree1:AddNode( "Item1", { "laptop1.png", "laptop2.png" } )
      MainForm:Tree1:AddTreeItem( "Item1.1", { "card_mast.png", "card_visa.png" } )
      MainForm:Tree1:AddTreeItem( "Item1.2", NIL )
   MainForm:Tree1:EndNode()

   MainForm:Tree1:AddNode( "Item2", { "laptop1.png", "laptop2.png" } )
      MainForm:Tree1:AddTreeItem( "Item2.1", { "card_mast.png", "card_visa.png" } )

      MainForm:Tree1:AddNode( "Item2.2", { "laptop1.png", "laptop2.png" } )
         MainForm:Tree1:AddTreeItem( "Item2.2.1", { "card_mast.png", "card_visa.png" } )
      MainForm:Tree1:EndNode()

      MainForm:Tree1:AddTreeItem( "Item2.3", { "card_mast.png", "card_visa.png" } )
   MainForm:Tree1:EndNode()

   MainForm:Tree1:AddItem( "New Item1", 4, { "white_paper.png" } )
   MainForm:Tree1:AddItem( "New Item2", 1, { "white_paper.png" } )

RETURN NIL

STATIC FUNCTION TreeNoRoot()

   IF MainForm:Tree1:RootButton == .T.
      MainForm:Tree1:RootButton := .F.
   ELSE
      MainForm:Tree1:RootButton := .T.
   ENDIF

RETURN NIL

STATIC FUNCTION TreeCaption()

   IF MainForm:Tree1:Caption == ""
      MainForm:Tree1:Caption := "This is a caption"
   ELSE
      MainForm:Tree1:Caption := NIL
   ENDIF

RETURN NIL

STATIC FUNCTION TreeNoImages()

   IF LEN( MainForm:Tree1:ItemImages ) == 0
      MainForm:Tree1:ItemImages := { "folder_close.png", "folder_open.png" }
      MainForm:Tree1:NodeImages := { "world.png", "world_red.png" }
   ELSE
      MainForm:Tree1:ItemImages := {}
      MainForm:Tree1:NodeImages := {}
   ENDIF

   MainForm:Tree1:DeleteAllItems()

   MainForm:Tree1:AddNode( "Item1" )
      MainForm:Tree1:AddTreeItem( "Item1.1" )
      MainForm:Tree1:AddTreeItem( "Item1.2" )
   MainForm:Tree1:EndNode()

   MainForm:Tree1:AddNode( "Item2" )
      MainForm:Tree1:AddTreeItem( "Item2.1" )

      MainForm:Tree1:AddNode( "Item2.2" )
         MainForm:Tree1:AddTreeItem( "Item2.2.1" )
      MainForm:Tree1:EndNode()

      MainForm:Tree1:AddTreeItem( "Item2.3" )
   MainForm:Tree1:EndNode()

RETURN NIL
